{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, CTL3D interface}
unit Ctl3D;

interface

uses WinTypes, WinProcs, Strings, WinDos;

type
  TCtl3dColorChange = function: bool;
  TCtl3dAutoSubclass = function(hinstApp: THandle): bool;
  TCtl3dRegister = function(hinstApp: THandle): bool;
  TCtl3dUnregister = function(hinstApp: THandle): bool;

function LoadCtl3d: bool;
procedure FreeCtl3d;

var
  HCtl3d: THandle;
  Ctl3dColorChange: TCtl3dColorChange;
  Ctl3dAutoSubclass: TCtl3dAutoSubclass;
  Ctl3dRegister: TCtl3dRegister;
  Ctl3dUnregister: TCtl3dUnregister;

implementation

const
  IdCtl3dColorChange = 6;
  IdCtl3dAutoSubclass = 16;
  IdCtl3dRegister = 12;
  IdCtl3dUnregister = 13;

function LoadCtl3d: bool;
var
  FN: array[0..160] of char;
  SearchRec: TSearchRec;
  Err: boolean;
begin
  if HCtl3d >= 32 then
  begin
    LoadCtl3d := true;
    exit;
  end
  else
    LoadCtl3d := false;

  GetSystemDirectory(FN,SizeOf(FN));
  StrCat(FN,'\CTL3D.DLL');
  FindFirst(FN,faAnyFile,SearchRec);
  if DosError <> 0 then exit;

  HCtl3d := LoadLibrary('CTL3D.DLL');
  if HCtl3d < 32 then exit;

  Err := false;
  @Ctl3dColorChange := GetProcAddress(HCtl3d, PChar(IdCtl3dColorChange));
  if @Ctl3dColorChange=nil then Err := true;

  @Ctl3dAutoSubclass := GetProcAddress(HCtl3d, PChar(IdCtl3dAutoSubclass));
  if @Ctl3dAutoSubclass=nil then Err := true;

  @Ctl3dRegister := GetProcAddress(HCtl3d, PChar(IdCtl3dRegister));
  if @Ctl3dRegister=nil then Err := true;

  @Ctl3dUnregister := GetProcAddress(HCtl3d, PChar(IdCtl3dUnregister));
  if @Ctl3dUnregister=nil then Err := true;

  if Err then
  begin
    FreeLibrary(HCtl3d);
    HCtl3d := 0;
  end
  else begin
    LoadCtl3d := true;
    Ctl3dRegister(HInstance);
    Ctl3dAutoSubclass(HInstance);
  end;
end;

procedure FreeCtl3d;
begin
  if HCtl3d >= 32 then
  begin
    Ctl3dUnregister(HInstance);
    FreeLibrary(HCtl3d);
    HCtl3d := 0;
  end;
end;

begin
  HCtl3d := 0;
end.