{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, command message procedures of VT win}
procedure VTWindow.CMFileNewConnection(var Msg: TMessage);
var
  Command, Command2: array[0..90] of char;
  GetHNRec: TGetHNRec; {record for dialog box}
  i: integer;
  FName, KeyCnfFN: array[0..fsPathName] of char;
  NumStr: String[6];
  Temp: array[0..6] of char;
begin
  if Connecting then exit;

  HelpId := HlpFileNewConnection;
  GetHNRec.SetupFN := ts.SetupFName;
  GetHNRec.PortType := ts.PortType;
  GetHNRec.Telnet := ts.Telnet;
  GetHNRec.TCPPort := ts.TCPPort;

  if not cv.Ready then
    GetHNRec.HostName := Command
  else begin
    StrCopy(Command,'teraterm ');
    GetHNRec.HostName := @Command[9];
  end;

  if not LoadTTDLG then exit;
  if GetHostName(HWindow,@GetHNRec) then
  begin
    if (not cv.Ready) then
    begin
      ts.PortType := GetHNRec.PortType;
      ts.Telnet := GetHNRec.Telnet;
      ts.TCPPort := GetHNRec.TCPPort;
      ts.ComPort := GetHNRec.ComPort;

      FName[0] := #0;
      if LoadTTSET then
        ParseParam(Command, @ts, TopicName);
      FreeTTSET;
      if StrLen(FName)>0 then StrCopy(ts.SetupFName,FName);
      SetKeyMap;
      Connecting := true;
      ChangeTitle;
      CommOpen(HWindow,@ts,@cv);
      ResetSetup;
    end
    else begin
      if GetHNRec.PortType=IdSerial then
      begin
        Command[8] := #0;
        StrCat(Command,' /C=');
        i := StrLen(Command);
        Command[i] := char(GetHNRec.ComPort+$30);
        Command[i+1] := #0;
      end
      else begin
        StrCopy(Command2, @Command[9]);
        Command[9] := #0;
        if GetHNRec.Telnet=0 then
          StrCat(Command,' /T=0')
        else
          StrCat(Command,' /T=1');
        if GetHNRec.TCPPort<65535 then
        begin
          Str(GetHNRec.TCPPort,NumStr);
          StrPCopy(Temp,NumStr);
          StrCat(Command,' /P=');
          StrCat(Command,Temp);                    
        end;
        StrCat(Command,' ');
        StrLCat(Command, Command2, SizeOf(Command)-1);
      end;
      WinExec(Command,sw_show);
    end;
  end;
  FreeTTDLG;
end;

procedure VTWindow.CMFileLog(var Msg: TMessage);
begin
  HelpId := HlpFileLog;
  LogStart;
end;

procedure VTWindow.CMFileSend(var Msg: TMessage);
begin
  HelpId := HlpFileSend;
  FileSendStart;
end;

procedure VTWindow.CMFileKermitRcv(var Msg: TMessage);
begin
  KermitStart(IdKmtReceive);
end;

procedure VTWindow.CMFileKermitGet(var Msg: TMessage);
begin
  HelpId := HlpFileKmtGet;
  KermitStart(IdKmtGet);
end;

procedure VTWindow.CMFileKermitSend(var Msg: TMessage);
begin
  HelpId := HlpFileKmtSend;
  KermitStart(IdKmtSend);
end;

procedure VTWindow.CMFileKermitFinish(var Msg: TMessage);
begin
  KermitStart(IdKmtFinish);
end;

procedure VTWindow.CMFileXRcv(var Msg: TMessage);
begin
  HelpId := HlpFileXmodemRecv;
  XMODEMStart(IdXReceive);
end;

procedure VTWindow.CMFileXSend(var Msg: TMessage);
begin
  HelpId := HlpFileXmodemSend;
  XMODEMStart(IdXSend);
end;

procedure VTWindow.CMFileZRcv(var Msg: TMessage);
begin
  ZMODEMStart(IdZReceive);
end;

procedure VTWindow.CMFileZSend(var Msg: TMessage);
begin
  HelpId := HlpFileZmodemSend;
  ZMODEMStart(IdZSend);
end;

procedure VTWindow.CMFileBPRcv(var Msg: TMessage);
begin
  BPStart(IdBPReceive);
end;

procedure VTWindow.CMFileBPSend(var Msg: TMessage);
begin
  HelpId := HlpFileBPlusSend;
  BPStart(IdBPSend);
end;

procedure VTWindow.CMFileQVRcv(var Msg: TMessage);
begin
  QVStart(IdQVReceive);
end;

procedure VTWindow.CMFileQVSend(var Msg: TMessage);
begin
  HelpId := HlpFileQVSend;
  QVStart(IdQVSend);
end;

procedure VTWindow.CMFileChangeDir(var Msg: TMessage);
begin
  HelpId := HlpFileChangeDir;
  if not LoadTTDLG then exit;
  ChangeDirectory(HWindow,ts.FileDir);
  FreeTTDLG;
end;

procedure VTWindow.Print(MC: bool);
var
  VTPrnVar: TVTPrnVar;
begin
  if not PrnBox(HWindow,not MC and Select) then exit;

  {set print region}
  if not MC and
    ((PrnDlg.Flags and PD_Selection) <> 0) then
  begin
    {print selected region}
    VTPrnVar.PrintStart := SelectStart;
    VTPrnVar.PrintEnd := SelectEnd;
  end
  else if MC and not PrintEX then
  begin
    {print scroll region}
    VTPrnVar.PrintStart.X := 0;
    VTPrnVar.PrintStart.Y := Scroller^.YPos + CursorTop;
    VTPrnVar.PrintEnd.X := NumOfColumns;
    VTPrnVar.PrintEnd.Y := Scroller^.YPos + CursorBottom;
  end
  else begin
    {print current screen}
    VTPrnVar.PrintStart.X := 0;
    VTPrnVar.PrintStart.Y := Scroller^.YPos;
    VTPrnVar.PrintEnd.X := NumOfColumns;
    VTPrnVar.PrintEnd.Y := Scroller^.YPos + NumOfLines - 1;
  end;
  if VTPrnVar.PrintEnd.Y > BuffEnd-1 then
     VTPrnVar.PrintEnd.Y := BuffEnd-1;

  {start printing}
  if not PrnStart(@Self, ts.Title) then exit;

  if LoadTTFILE then
  begin
    LockBuffer;

    VTPrnVar.HWin := HWindow;
    VTPrnVar.PrintDC := PrintDC;
    VTPrnVar.ts := @ts;
    VTPrnVar.NumOfColumns := NumOfColumns;
    VTPrnVar.BuffStartAbs := BuffStartAbs;
    VTPrnVar.BufferSize := BufferSize;
    VTPrnVar.CodeBuff := CodeBuff;
    VTPrnVar.AttrBuff := AttrBuff;
    VTPrnVar.AttrBuff2 := AttrBuff2;

    VTPrint(@VTPrnVar);
    UnlockBuffer;

    FreeTTFILE;
  end;

  PrnStop;
end;

procedure VTWindow.CMFilePrint(var Msg: TMessage);
begin
  HelpId := HlpFilePrint;
  Print(false);
end;

procedure VTWindow.CMFileDisconnect(var Msg: TMessage);
begin
  PostMessage(HWindow, wm_User+MsgComNotify, 0, FD_CLOSE);
end;

procedure VTWindow.CMEditCopy(var Msg: TMessage);
begin
  LockBuffer;
  CBCopy(HWindow);
  UnlockBuffer;
end;

procedure VTWindow.CMEditPaste(var Msg: TMessage);
begin
  CBAddCR := false;
  CBStartPaste(HWindow);
end;

procedure VTWindow.CMEditPasteCR(var Msg: TMessage);
begin
  CBAddCR := true;
  CBStartPaste(HWindow);
end;

procedure VTWindow.CMEditClearScreen(var Msg: TMessage);
begin
  LockBuffer;
  BuffScroll(NumOfLines);
  MoveCursor(0,0);
  UnlockBuffer;
  WinOrgX := 0;
  WinOrgY := 0;
  NewOrgX := 0;
  NewOrgY := 0;
  if BufferFull then
    Scroller^.YPos := NumOfLinesInBuff - 2*NumOfLines;
  Scroller^.SetRange(Scroller^.XRange,BuffEnd-WinHeight);
  Scroller^.ScrollTo(0,PageStart);
  CaretOn;
end;

procedure VTWindow.CMEditClearBuffer(var Msg: TMessage);
begin
  LockBuffer;
  ClearBuffer;
  UnlockBuffer;
  CaretOn;
end;

procedure VTWindow.CMSetupTerminal(var Msg: TMessage);
begin
  HelpId := HlpSetupTerminal;
  if not LoadTTDLG then exit;
  SetupTerminal(HWindow,@ts,ts.Language);
  FreeTTDLG;
  if ts.Ok then InitTerm;
end;

procedure VTWindow.InitTerm;
begin
  if ts.Language=IdJapanese then
    ResetCharSet;

  with ts do begin
    if (TerminalWidth<>NumOfColumns) or
       (TerminalHeight<>NumOfLines) then
    begin
      LockBuffer;
      ChangeTerminalSize(TerminalWidth,
                         TerminalHeight);
      UnlockBuffer;
      CaretOn;
    end
    else if (TermIsWin>0) and
            ((TerminalWidth<>WinWidth) or
             (TerminalHeight<>WinHeight)) then
      ChangeWindowSize(TerminalWidth,TerminalHeight);
  end;
end;


procedure VTWindow.CMSetupWindow(var Msg: TMessage);
begin
  HelpId := HlpSetupWindow;
  ts.VTFlag := true;
  ts.SampleFont := VTFont[0];

  if not LoadTTDLG then exit;
  SetupWin(HWindow, @ts);
  FreeTTDLG;

  if ts.Ok then InitWin;
end;

procedure VTWindow.InitWin;
var
  i, j: integer;
  Ny: word;
begin
  {Change window caption}
  ChangeTitle;

  {Change buffer}
  if (ts.EnableScrollBuff>0) then
  begin
    if (ts.ScrollBuffMax < NumOfLines) then
      ts.ScrollBuffMax := NumOfLines;
    Ny := ts.ScrollBuffMax;
  end
  else
    Ny := NumOfLines;

  if NumOfLinesInBuff<>Ny then
  begin
    ChangeBuffer(NumOfColumns,Ny);
    if ts.EnableScrollBuff>0 then
      ts.ScrollBuffMax := NumOfLinesInBuff;

    if BuffEnd < WinHeight then
      ChangeWindowSize(WinWidth,BuffEnd)
    else if (BuffEnd=WinHeight) and (ts.EnableScrollBuff>0) then
    begin
      i := WinWidth;
      j := WinHeight;
      Scroller^.YPos := 0;
      Scroller^.SetRange(Scroller^.XRange,1);
      Scroller^.YRange := 0;
      ChangeWindowSize(i,j);
    end
    else begin
      if Scroller^.YPos > BuffEnd-WinHeight then
         Scroller^.YPos := BuffEnd-WinHeight;
      Scroller^.SetRange(Scroller^.XRange,BuffEnd-WinHeight);
    end;
  end;

  {Menu bar / Popup menu}
  if ts.HideTitle=0 then
    SwitchMenu;

  {3D dialog box}
  if ts.Dlg3d>0 then
    LoadCtl3d
  else
    FreeCtl3d;

  if BackGround<>0 then DeleteObject(BackGround);
  BackGround := CreateSolidBrush(ts.VTColor[1]);

  InvalidateRect(HWindow,nil,true);

  {Change caret shape}
  ChangeCaret;
end;


procedure VTWindow.CMSetupFont(var Msg: TMessage);
var
  Ok: bool;
begin
  HelpId := HlpSetupFont;
  if not LoadTTDLG then exit;
  SetLogFont;
  Ok := ChooseFontDlg(HWindow,@VTLogFont,@ts.EnableBold);
  FreeTTDLG;
  if not OK then exit;

  StrCopy(ts.VTFont,VTLogFont.lfFaceName);
  ts.VTFontSize.x := VTLogFont.lfWidth;
  ts.VTFontSize.y := VTLogFont.lfHeight;
  ts.VTFontCharSet := VTLogFont.lfCharSet;

  ChangeFont;

  ChangeWindowSize(WinWidth,WinHeight);

  ChangeCaret;
end;

procedure VTWindow.CMSetupKeyboard(var Msg: TMessage);
begin
  HelpId := HlpSetupKeyboard;
  if not LoadTTDLG then exit;
  SetupKeyboard(HWindow,@ts,ts.Language);
  FreeTTDLG;

  if ts.Ok and 
     (ts.Language=IdJapanese) then
    ResetIME;
end;

procedure VTWindow.CMSetupSerialPort(var Msg: TMessage);
begin
  HelpId := HlpSetupSerialPort;
  if not LoadTTDLG then exit;
  SetupSerialPort(HWindow, @ts);
  FreeTTDLG;

  if ts.Ok then
  begin
    if cv.Open then
    begin
      if ts.ComPort <> cv.ComPort then
      begin
        CommClose(@cv);
        CommOpen(HMainWin,@ts,@cv);
      end
      else
        CommResetSerial(@ts,@cv);
    end
    else
      CommOpen(HMainWin,@ts,@cv);
  end;
end;

procedure VTWindow.CMSetupTCPIP(var Msg: TMessage);
begin
  HelpId := HlpSetupTCPIP;
  if not LoadTTDLG then exit;
  SetupTCPIP(HWindow, @ts);
  FreeTTDLG;
end;

procedure VTWindow.CMSetupGeneral(var Msg: TMessage);
var
  Temp: array[0..7] of char;
begin
  HelpId := HlpSetupGeneral;
  if not LoadTTDLG then exit;
  if SetupGeneral(HWindow,@ts.PortType,@ts.Language) then
  begin
    case ts.PortType of
      IdSerial: StrCopy(Temp,'serial')
    else {IdFile -> IdTCPIP}
      StrCopy(Temp,'tcpip');
    end;
    WritePrivateProfileString('Tera Term','Port',Temp,ts.SetupFName);
    LoadDefaultSet(ts.SetupFName);

    ResetCharset;
    ResetIME;
  end;
  FreeTTDLG;
end;

procedure VTWindow.CMSetupSave(var Msg: TMessage);
var
  TmpSetupFN: array[0..fsPathName] of char;
  Ok: bool;
begin
  StrCopy(TmpSetupFN, ts.SetupFName);
  if not LoadTTFILE then exit;
  HelpId := HlpSetupSave;
  Ok := GetSetupFname(HWindow,true,@ts);
  FreeTTFILE;
  if not Ok then exit;

  if LoadTTSET then
  begin
    {write current setup values to file}
    WriteIniFile(ts.SetupFName,@ts);
    {copy host list}
    CopyHostList(TmpSetupFN,ts.SetupFName);
    FreeTTSET;
  end;

  ChangeDefaultSet(@ts);
end;

procedure VTWindow.ResetSetup;
begin
  ChangeFont;
  ChangeWindowSize(WinWidth,WinHeight);
  ChangeCaret;

  {setup terminal}
  InitTerm;

  {setup window}
  InitWin;

  {Language & IME}
  ResetIME;

  {if serial port, change port parameters}
  if cv.Ready and (cv.PortType=IdSerial) and
     (cv.ComPort=ts.ComPort) then
    CommResetSerial(@ts,@cv);

  {change TEK window}
  if HTEKWin<>0 then TEKPtr^.RestoreSetup;
end;

procedure VTWindow.CMSetupRestore(var Msg: TMessage);
var
  i: integer;
  Ok: bool;
begin
  HelpId := HlpSetupRestore;
  if not LoadTTFILE then exit;
  Ok := GetSetupFname(HWindow,false,@ts);
  FreeTTFILE;
  if not Ok then exit;

  if LoadTTSET then
    ReadIniFile(ts.SetupFName,@ts);
  FreeTTSET;

  ChangeDefaultSet(@ts);

  ResetSetup;
end;

procedure VTWindow.CMControlResetTerminal(var Msg: TMessage);
begin
  Scroller^.ScrollTo(0,PageStart);
  ResetTerminal;
  CaretOn;
end;

procedure VTWindow.CMControlAreYouThere(var Msg: TMessage);
begin
  if cv.Ready and (cv.PortType=IdTCPIP) then
    TelSendAYT;
end;

procedure VTWindow.CMControlSendBreak(var Msg: TMessage);
begin
  if cv.Ready then
    case cv.PortType of
      IdTCPIP: TelSendBreak;
      IdSerial: CommSendBreak(@cv);
    end;
end;

procedure VTWindow.CMControlResetPort(var Msg: TMessage);
begin
  CommResetSerial(@ts,@cv);
end;

procedure VTWindow.CMControlOpenTEK(var Msg: TMessage);
begin
  TEKActivate;
end;

procedure VTWindow.CMControlCloseTEK(var Msg: TMessage);
begin
  if (HTEKWin=0) or
     not IsWindowEnabled(HTEKWin) then
  begin
    messagebeep(0);
    exit;
  end;
  TEKPtr^.CloseWindow;
end;

procedure VTWindow.CMControlMacro(var Msg: TMessage);
var
  Cmnd: array[0..39] of char;
begin
  SetTopic;
  if not InitDDE then exit;
  strcopy(Cmnd,'TTMACRO /D=');
  strcat(Cmnd,TopicName);
  if WinExec(Cmnd,SW_MINIMIZE) < 32 then
    EndDDE;
end;

procedure VTWindow.CMHelpIndex(var Msg: TMessage);
begin
  if ts.Language=IdJapanese then
    WinHelp(HWindow, HelpJpn, Help_Index, 0)
  else
    WinHelp(HWindow, HelpEng, Help_Index, 0);
end;

procedure VTWindow.CMHelpUsing(var Msg: TMessage);
begin
  WinHelp(HWindow, '', Help_HelpOnHelp, 0);
end;

procedure VTWindow.CMAbout(var Msg: TMessage);
begin
  if not LoadTTDLG then exit;
  AboutDialog(HWindow);
  FreeTTDLG;
end;