{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TTFILE.DLL, Print routine of VT window}
unit VTPrn;

interface
{$I teraterm.inc}

{$IFDEF Delphi}
uses WinTypes, WinProcs, OWindows, Strings, TTTypes, TTFTypes;
{$ELSE}
uses WinTypes, WinProcs, WObjects, Strings, Win31, TTTypes, TTFTypes;
{$ENDIF}

procedure VTPrint(VTPrnVar: PVTPrnVar); export;

implementation

procedure VTPrint(VTPrnVar: PVTPrnVar);

  function GetLinePtr(Line: integer): longint;
  var
    Ptr: longint;
  begin
  with VTPrnVar^ do begin
    Ptr := longmul(BuffStartAbs + Line, NumOfColumns);
    if Ptr >= BufferSize then Ptr := Ptr - BufferSize;
    GetLinePtr := Ptr;
  end;
  end;

  function NextLinePtr(Ptr: longint): longint;
  begin
  with VTPrnVar^ do begin
    Ptr := Ptr + longint(NumOfColumns);
    if Ptr >= BufferSize then Ptr := Ptr - BufferSize; 
    NextLinePtr := Ptr;
  end;
  end;

var
  PrnLogFont: TLogFont;
  PrnFont: array[0..AttrFontMask] of HFont;
  Metrics: TTextMetric;
  FW,FH: integer;
  Mergin: TRect;
  PPI, PPI2: TPoint;
  White, Black: TColorRef;
  i, j, count: integer;
  IStart, IEnd: integer;
  X, Y: integer;
  TmpPtr: Longint;
  CurAttr, TempAttr: byte;
  CurAttr2, TempAttr2: byte;
  RText: TRect;
  Dx: array[0..255] of integer;
  DC: HDC;
begin
with VTPrnVar^ do begin
  if PrintDC = 0 then exit;
  if (PrintStart.Y=PrintEnd.Y) and (PrintStart.X=PrintEnd.X) then exit;

  StartPage(PrintDC);

  DC := GetDC(HWin);

  FillChar(PrnLogFont, SizeOf(TLogFont), #0);

  with PrnLogFont do
  begin
    if StrLen(ts^.PrnFont)=0 then
    begin
      lfHeight := ts^.VTFontSize.y;
      lfWidth := ts^.VTFontSize.x;
      lfCharSet := ts^.VTFontCharSet;
      StrCopy(lfFaceName, ts^.VTFont);
    end
    else begin
      lfHeight := ts^.PrnFontSize.y;
      lfWidth := ts^.PrnFontSize.x;
      lfCharSet := ts^.PrnFontCharSet;
      StrCopy(lfFaceName, ts^.PrnFont);
    end;
  end;

  {create test font}
  PrnLogFont.lfWeight := FW_Normal;
  PrnLogFont.lfUnderline := 0;
  PrnFont[0] := CreateFontIndirect(PrnLogFont);

  SelectObject(DC, PrnFont[0]);
  GetTextMetrics(DC, Metrics);

  {Adjust font size}
  PrnLogFont.lfHeight := Metrics.tmHeight;
  PrnLogFont.lfWidth := Metrics.tmAveCharWidth;
    {pixels per inch}
  PPI.X := GetDeviceCaps(PrintDC,LogPixelSX);
  PPI.Y := GetDeviceCaps(PrintDC,LogPixelSY);
  PPI2.X := GetDeviceCaps(DC,LogPixelSX);
  PPI2.Y := GetDeviceCaps(DC,LogPixelSY);

  PrnLogFont.lfHeight := round(PrnLogFont.lfHeight*PPI.Y/PPI2.Y);
  PrnLogFont.lfWidth := round(PrnLogFont.lfWidth*PPI.X/PPI2.X);

  Mergin.left := round(PPI.X*0.25); {horizontal mergin: about 1/4 inch}
  Mergin.right := GetDeviceCaps(PrintDC,HorzRes) - Mergin.left;
  Mergin.top := round(PPI.Y*1.0); {virtical mergin: about 1 inch}
  Mergin.bottom := GetDeviceCaps(PrintDC,VertRes) - Mergin.top;

  ReleaseDC(HWin,DC);
  DeleteObject(PrnFont[0]); {Delete test font}

  {Create New Fonts}

  {Normal Font}
  PrnLogFont.lfWeight := FW_Normal;
  PrnLogFont.lfUnderline := 0;
  PrnFont[0] := CreateFontIndirect(PrnLogFont);
  SelectObject(PrintDC,PrnFont[0]);
  GetTextMetrics(PrintDC, Metrics);
  FW := Metrics.tmAveCharWidth;
  FH := Metrics.tmHeight;
  {Under line}
  PrnLogFont.lfUnderline := 1;
  PrnFont[AttrUnder] := CreateFontIndirect(PrnLogFont);

  if ts^.EnableBold>0 then
  begin
    {Bold}
    PrnLogFont.lfUnderLine := 0;
    PrnLogFont.lfWeight := FW_Bold;
    PrnFont[AttrBold] := CreateFontIndirect(PrnLogFont);
    {Bold + Underline}
    PrnLogFont.lfUnderLine := 1;
    PrnFont[AttrBold or AttrUnder] := CreateFontIndirect(PrnLogFont);
  end
  else begin
    PrnFont[AttrBold] := PrnFont[AttrDefault];
    PrnFont[AttrBold or AttrUnder] := PrnFont[AttrUnder];
  end;
  {Special font}
  PrnLogFont.lfWeight := FW_Normal;
  PrnLogFont.lfUnderLine := 0;
  PrnLogFont.lfWidth := FW; {adjust width}
  PrnLogFont.lfHeight := FH;
  PrnLogFont.lfCharset := 1;

  StrCopy(PrnLogFont.lfFacename,'Tera Special');
  PrnFont[AttrSpecial] := CreateFontIndirect(PrnLogFont);
  PrnFont[AttrSpecial or AttrBold] := PrnFont[AttrSpecial];
  PrnFont[AttrSpecial or AttrUnder] := PrnFont[AttrSpecial];
  PrnFont[AttrSpecial or AttrBold or AttrUnder] := PrnFont[AttrSpecial];

  Black := RGB(0,0,0);
  White := RGB(255,255,255);
  SetTextColor(PrintDC, black);
  SetBkColor(PrintDC,white);
  for i := 0 to 255 do
    Dx[i] := FW;

  TempAttr := AttrDefault;
  TempAttr2 := AttrDefault2;
  Y := Mergin.top;

  TmpPtr := GetLinePtr(PrintStart.Y);
  for j := PrintStart.Y to PrintEnd.Y do
  begin
    if j=PrintStart.Y then IStart := PrintStart.X
                      else IStart := 0;
    if j=PrintEnd.Y then IEnd := PrintEnd.X - 1
                    else IEnd := NumOfColumns - 1;

    if Y+FH > Mergin.bottom then
    begin
      {next page}
      EndPage(PrintDC);
      StartPage(PrintDC);
      Y := Mergin.top;
    end;

    X := Mergin.left;
    RText.top := Y;
    RText.bottom := Y + FH;
    i := IStart;
    repeat
      CurAttr := byte(AttrBuff[TmpPtr+i]) and not AttrKanji;
      CurAttr2 := byte(AttrBuff2[TmpPtr+i]);

      {count := 1;}
      count := 0;
      while (i+count <= IEnd) and
            (CurAttr=byte(AttrBuff[TmpPtr+i+count]) and not AttrKanji) and
            (CurAttr2=byte(AttrBuff2[TmpPtr+i+count])) or
            (byte(AttrBuff[TmpPtr+i+count-1]) and AttrKanji <> 0) do
        Inc(count);

      if (CurAttr <> TempAttr) or
         (CurAttr2 <> TempAttr2) then
      begin
        SelectObject(PrintDc, PrnFont[CurAttr and AttrFontMask]);

        if CurAttr and AttrReverse <> 0 then
        begin
          SetTextColor(PrintDC,White);
          SetBkColor(  PrintDC,Black);
        end
        else begin
          SetTextColor(PrintDC,Black);
          SetBkColor(  PrintDC,White);
        end;

        TempAttr := CurAttr;
        TempAttr2 := CurAttr2;
      end;

      RText.left := X;
      RText.right := X + count*FW;
      ExtTextOut(PrintDc,X,Y,6,@RText,@CodeBuff[TmpPtr+i]
                 ,count,@Dx);

      X := X + count*FW;
      i := i+count;
    until  (i>IEnd);

    Y := Y + FH;
    TmpPtr := NextLinePtr(TmpPtr);
  end;

  EndPage(PrintDC);

  for i := 0 to AttrFontMask do
  begin
    for j := i+1 to AttrFontMask do
      if PrnFont[j]=PrnFont[i] then
        PrnFont[j] := 0;
    if PrnFont[i]<>0 then DeleteObject(PrnFont[i]);
  end;

end;
end;

end.