{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, VT window WM methods}

procedure VTWindow.WMDestroy(var Msg: TMessage);
var
  i, j: integer;
begin
  EndKeyboard;

  FreeCtl3d;

  {Disable drag-drop}
  DragAcceptFiles(HWindow,false);

  EndDDE;

  if cv.TelFlag then EndTelnet;
  CommClose(@cv);

  if ts.Language=IdEnglish then
    WinHelp(HWindow, HelpEng, Help_Quit, 0)
  else
    WinHelp(HWindow, HelpJpn, Help_Quit, 0);

  FreeWINNLS;
  FreeTTSET;
  repeat
    FreeTTDLG;
  until (HTTDLG<32) or (TTDLGUseCount=0);

  LogEnd;
  FileSendEnd;
  ProtoEnd;
  repeat
  until not FreeTTFILE;

  if HTEKWin<>0 then TEKPtr^.CloseWindow;

  {Delete fonts}
  for i := 0 to AttrFontMask do
  begin
    for j := i+1 to AttrFontMask do
      if VTFont[j]=VTFont[i] then
        VTFont[j] := 0;
    if VTFont[i]<>0 then DeleteObject(VTFont[i]);
  end;

  DeleteObject(BackGround);

  FreeBuffer;
  TWindow.WMDestroy(Msg);
end;

procedure VTWindow.WMDropFiles(var Msg: TMessage);
begin
  if (SendVar=nil) and NewFileVar(SendVar) then
  begin
    if DragQueryFile(Msg.wParam,0,SendVar^.FullName,SizeOf(SendVar^.FullName))>0 then
    begin
      SendVar^.DirLen := 0;
      ts.TransBin := 0;
      FileSendStart
    end
    else
      FreeFileVar(SendVar);
  end;
  DragFinish(Msg.wParam);
end;

procedure VTWindow.WMGetMinMaxInfo(var Msg: TMessage);
begin
  PMinMaxInfo(Msg.lParam)^.ptMaxSize.X := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxSize.Y := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxTrackSize.X := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxTrackSize.Y := 10000;
end;

procedure VTWindow.InitMenu(var Menu: HMenu);
begin
  Menu := LoadMenu(HInstance, PChar(id_Menu));
  FileMenu := GetSubMenu(Menu,cm_File);
  TransMenu := GetSubMenu(FileMenu,cm_Transfer);
  EditMenu := GetSubMenu(Menu,cm_Edit);
  SetupMenu := GetSubMenu(Menu,cm_Setup);
  ControlMenu := GetSubMenu(Menu,cm_Control);
end;

procedure VTWindow.InitMenuPopup(SubMenu: HMenu);
begin
  if SubMenu = FileMenu then
  begin
    if Connecting then
      EnableMenuItem(FileMenu,cm_FileNewConnection,mf_ByCommand or mf_Grayed)
    else
      EnableMenuItem(FileMenu,cm_FileNewConnection,mf_ByCommand or mf_Enabled);

    if (not cv.Ready) or (LogVar<>nil) or (cv.PortType=IdFile) then
      EnableMenuItem(FileMenu,cm_FileLog,mf_ByCommand or mf_Grayed)
    else
      EnableMenuItem(FileMenu,cm_FileLog,mf_ByCommand or mf_Enabled);

    if (not cv.Ready) or (SendVar<>nil) or (FileVar<>nil) or
       (cv.PortType=IdFile) then
    begin
      EnableMenuItem(FileMenu,cm_FileSend,mf_ByCommand or mf_Grayed);
      EnableMenuItem(FileMenu,4,mf_ByPosition or mf_Grayed); {Transfer}
      EnableMenuItem(FileMenu,cm_FileChangeDir,mf_ByCommand or mf_Grayed);
      EnableMenuItem(FileMenu,cm_FileDisconnect,mf_ByCommand or mf_Grayed);
    end
    else begin
      EnableMenuItem(FileMenu,cm_FileSend,mf_ByCommand or mf_Enabled);
      EnableMenuItem(FileMenu,4,mf_ByPosition or mf_Enabled); {Transfer}
      EnableMenuItem(FileMenu,cm_FileChangeDir,mf_ByCommand or mf_Enabled);
      EnableMenuItem(FileMenu,cm_FileDisconnect,mf_ByCommand or mf_Enabled);
    end
  end
  else if SubMenu = TransMenu then
  begin
    if (cv.PortType=IdSerial) and
       ((ts.DataBit=IdDataBit7) or (ts.Flow=IdFlowX)) then
    begin
      EnableMenuItem(TransMenu,1,mf_ByPosition or mf_Grayed);  {XMODEM}
      EnableMenuItem(TransMenu,4,mf_ByPosition or mf_Grayed);  {Quick-VAN}
    end
    else begin
      EnableMenuItem(TransMenu,1,mf_ByPosition or mf_Enabled); {XMODEM}
      EnableMenuItem(TransMenu,4,mf_ByPosition or mf_Enabled); {Quick-VAN}
    end;
    if (cv.PortType=IdSerial) and
       (ts.DataBit=IdDataBit7) then
    begin
      EnableMenuItem(TransMenu,2,mf_ByPosition or mf_Grayed); {ZMODEM}
      EnableMenuItem(TransMenu,3,mf_ByPosition or mf_Grayed); {B-Plus}
    end
    else begin
      EnableMenuItem(TransMenu,2,mf_ByPosition or mf_Enabled); {ZMODEM}
      EnableMenuItem(TransMenu,3,mf_ByPosition or mf_Enabled); {B-Plus}
    end;
  end
  else if SubMenu = EditMenu then
  begin
    if Select then
      EnableMenuItem(EditMenu,cm_EditCopy,mf_ByCommand or mf_Enabled)
    else
      EnableMenuItem(EditMenu,cm_EditCopy,mf_ByCommand or mf_Grayed);

    if cv.Ready and
       (SendVar=nil) and (FileVar=nil) and
       (cv.PortType<>IdFile) and
       (IsClipboardFormatAvailable(cf_Text) or
        IsClipboardFormatAvailable(cf_OEMText)) then
    begin
      EnableMenuItem(EditMenu,cm_EditPaste,mf_ByCommand or mf_Enabled);
      EnableMenuItem(EditMenu,cm_EditPasteCR,mf_ByCommand or mf_Enabled);
    end
    else begin
      EnableMenuItem(EditMenu,cm_EditPaste,mf_ByCommand or mf_Grayed);
      EnableMenuItem(EditMenu,cm_EditPasteCR,mf_ByCommand or mf_Grayed);
    end;
  end
  else if SubMenu = SetupMenu then
    if cv.Ready and
       ((cv.PortType=IdTCPIP) or (cv.PortType=IdFile)) or
       (SendVar<>nil) or (FileVar<>nil) or Connecting then
      EnableMenuItem(SetupMenu,cm_SetupSerialPort,mf_ByCommand or mf_Grayed)
    else
      EnableMenuItem(SetupMenu,cm_SetupSerialPort,mf_ByCommand or mf_Enabled)

  else if SubMenu = ControlMenu then
  begin
    if cv.Ready and
       (SendVar=nil) and (FileVar=nil) then
    begin
      EnableMenuItem(ControlMenu,cm_ControlSendBreak,mf_ByCommand or mf_Enabled);
      if cv.PortType=IdSerial then
        EnableMenuItem(ControlMenu,cm_ControlResetPort,mf_ByCommand or mf_Enabled);
    end
    else begin
      EnableMenuItem(ControlMenu,cm_ControlSendBreak,mf_ByCommand or mf_Grayed);
      EnableMenuItem(ControlMenu,cm_ControlResetPort,mf_ByCommand or mf_Grayed);
    end;

    if cv.Ready and cv.TelFlag and (FileVar=nil) then
      EnableMenuItem(ControlMenu,cm_ControlAreYouThere,mf_ByCommand or mf_Enabled)
    else
      EnableMenuItem(ControlMenu,cm_ControlAreYouThere,mf_ByCommand or mf_Grayed);

    if HTEKWin=0 then EnableMenuItem(ControlMenu,cm_ControlCloseTEK,mf_ByCommand or mf_Grayed)
                 else EnableMenuItem(ControlMenu,cm_ControlCloseTEK,mf_ByCommand or mf_Enabled);

    if (not cv.Ready) or (ConvH<>0) or (FileVar<>nil) then
      EnableMenuItem(ControlMenu,cm_ControlMacro,mf_ByCommand or mf_Grayed)
    else
      EnableMenuItem(ControlMenu,cm_ControlMacro,mf_ByCommand or mf_Enabled);

  end;

end;

procedure VTWindow.WMInitMenuPopup(var Msg: TMessage);
begin
  InitMenuPopup(Msg.wParam);
end;

procedure VTWindow.WMSysKeyDown(var Msg: TMessage);
begin
  case Msg.wParam of
    VK_F10: WMKeyDown(Msg);
  else
    DefWndProc(Msg);
  end;
end;

procedure VTWindow.WMSysKeyUp(var Msg: TMessage);
begin
  case Msg.wParam of
    VK_F10: WMKeyUp(Msg);
  else
    DefWndProc(Msg);
  end;
end;

procedure VTWindow.WMSysChar(var Msg: TMessage);
var
  Code: byte;
  Count, i: integer;
begin
  if ts.MetaKey>0 then
  begin
    if TalkStatus<>IdTalkKeyb then exit;

    Code  := Msg.wParam and $ff;
    Count := Msg.lParam and $007f;

    for i:=1 to Count do
    begin
      CommTextOut(@cv,#$1B,1);
      CommTextOut(@cv,@Code,1);
      if ts.LocalEcho>0 then
      begin
        CommTextEcho(@cv,#$1B,1);
        CommTextEcho(@cv,@Code,1);
      end;
    end;
    exit;
  end;

  DefWndProc(Msg);
end;

procedure VTWindow.WMIMEReport(var Msg: TMessage);
var
  Str: PChar;
  Len: integer;
  TM: TMsg;
begin
  case Msg.wParam of
    IR_OPENCONVERT: OpenConv := true;
    IR_CLOSECONVERT: OpenConv := false;
    IR_STRING: begin
      Str := GlobalLock(Msg.lParam);
      Len := strlen(Str);
      if Len=1 then
      begin
        case Str[0] of
          ' ':
            if ControlKey then
              Str[0] := #0; {Ctrl-space}
        end;
      end;
      if ts.LocalEcho>0 then
        CommTextEcho(@cv,Str,Len);
      CommTextOut(@cv,Str,Len);
      GlobalUnlock(Msg.lParam);
      exit;
    end;
  end;
  DefWndProc(Msg);
end;

procedure VTWindow.WMKeyDown(var Msg: TMessage);
begin
  KeyDown(HWindow,Msg.wParam,Msg.lParam and $007f,HiWord(Msg.lParam) and $1ff);
end;

procedure VTWindow.WMKeyUp(var Msg: TMessage);
begin
  KeyUp(Msg.wParam);
end;

procedure VTWindow.WMChar(var Msg: TMessage);
var
  i, Count: integer;
  Code: byte;
begin
  if TalkStatus<>IdTalkKeyb then exit;

  Code  := Msg.wParam and $ff;
  Count := Msg.lParam and $007f;

  for i:=1 to Count do
  begin
    CommTextOut(@cv,@Code,1);
    if ts.LocalEcho>0 then
    CommTextEcho(@cv,@Code,1);
  end;
end;


procedure VTWindow.WMCommNotify(var Msg: TMessage);
begin
  if LoWord(Msg.lParam)<>CN_EVENT then exit;
  CommProcRRQ(@cv);
end;

procedure VTWindow.WMTimer(var Msg: TMessage);
var
  Point: TPoint;
begin
  if Msg.wParam=IdScrollTimer then
  begin
    Scroller^.AutoScroll;
    GetCursorPos(Point);
    ScreenToClient(HWindow,Point);
    if (Point.X < 0) or (Point.X >= ScreenWidth) or
       (Point.Y < 0) or (Point.Y >= ScreenHeight) then
      PostMessage(HWindow,wm_First+wm_MouseMove,MK_LBUTTON,makelong(Point.X,Point.Y));
    exit;
  end;

  KillTimer(HWindow, Msg.wParam);

  case Msg.wParam of
    IdDelayTimer: cv.CanSend := true;
    IdProtoTimer: if ProtoFlag then ProtoDlgTimeOut;
    IdDblClkTimer: DblClk := false;
    IdComEndTimer: begin
        if cv.TelFlag then EndTelnet;
        CommClose(@cv);
        SetDdeComReady(0);
        if (ts.PortType=IdTCPIP) and (ts.AutoWinClose>0) and
           IsWindowEnabled(HWindow) and
           ((HTEKWin=0) or IsWindowEnabled(HTEKWin)) then
          CloseWindow
        else
          ChangeTitle;
      end;
  end;

end;

procedure VTWindow.WMActivate(var Msg: TMessage);
begin

  if boolean(Msg.wparam)
  then begin
    Active := true;
    if (ts.Language=IdJapanese) and
       (HWINNLS>=32) then
      WINNLSEnableIME(0,true);
    ChangeCaret;
    ActiveWin := IdVT;
  end
  else begin
    if (ts.Language=IdJapanese) and
       (HWINNLS>=0) then
      {position & font of conv. window -> default}
      SetConversionWindow(HWindow,-1,0,0);
    DestroyCaret;
    Active := false;
  end;
  TWindow.WMActivate(Msg);
end;


procedure VTWindow.Paint(PaintDC: HDC; var PaintInfo:TPaintStruct);
var
  XStart, Xend, YStart, YEnd: integer;
begin
  if PaintInfo.fErase then
    FillRect(PaintDC, PaintInfo.rcPaint,Background);

  WinOrgX := Scroller^.XPos;
  WinOrgY := Scroller^.YPos-PageStart;
  NewOrgX := WinOrgX;
  NewOrgY := WinOrgY;

  XStart := PaintInfo.rcPaint.left div FontWidth + WinOrgX;
  YStart := PaintInfo.rcPaint.top div FontHeight + WinOrgY;
  XEnd := (PaintInfo.rcPaint.right-1) div FontWidth + WinOrgX;
  YEnd := (PaintInfo.rcPaint.bottom-1) div FontHeight + WinOrgY;

  LockBuffer;
  UpdateRect(PaintDC,XStart,YStart,XEnd,YEnd);
  UnlockBuffer;

  if FirstPaint then
  begin
    if strlen(TopicName)>0 then
    begin
      InitDDE;
      SendDDEReady;
    end;
    PostMessage(HWindow,wm_User+MsgComStart,0,0);
    FirstPaint := false;
  end;
end;

procedure VTWindow.WMSize(Var Msg: TMessage);
var
  Nx, Ny, NewX, NewY, dW, dH: integer;
  Point: TPoint;
begin
  TWindow.WMSize(Msg);
  MiniMized := Msg.wParam = SizeIconic;

  if FirstPaint and MiniMized then
  begin
    if strlen(TopicName)>0 then
    begin
      InitDDE;
      SendDDEReady;
    end;
    PostMessage(HWindow,wm_User+MsgComStart,0,0);
    FirstPaint := false;
    exit;
  end;
  if (MiniMized) or DontChangeSize then exit; 

  GetClientRect(HWindow,R);
  if AdjustSize then
  begin
    dW := ScreenWidth - R.right + R.left;
    dH := ScreenHeight - R.bottom + R.top;
    if (dW<>0) or (dH<>0) then
      SetWindowPos(HWindow,HWND_TOP,NewX,NewY,Attr.W+dW,Attr.H+dH,SWP_NoMove)
    else begin
      AdjustSize := false;

      NewX := Attr.X;
      NewY := Attr.Y;
      if Attr.X+Attr.W > CRTWidth then
      begin
        NewX := CRTWidth-Attr.W;
        if NewX < 0 then NewX := 0;
      end;
      if Attr.Y+Attr.H > CRTHeight then
      begin
        NewY := CRTHeight-Attr.H;
        if NewY < 0 then NewY := 0;
      end;
      if (NewX<>Attr.X) or (NewY<>Attr.Y) then
        SetWindowPos(HWindow,HWND_TOP,NewX,NewY,Attr.W,Attr.H,SWP_NoSize);

      Point.X := 0;
      Point.Y := ScreenHeight;
      ClientToScreen(HWindow,Point);
      CompletelyVisible := Point.Y <= CRTHeight;
      CaretOn;
    end;
  end
  else begin
    Nx := (R.right-R.left) div FontWidth;
    Ny := (R.bottom-R.top) div FontHeight;
    if ts.TermIsWin>0 then
    begin
      if Nx > BuffXMax then Nx := BuffXMax;
      if Ny > BuffYMax then Ny := BuffYMax;
    end else
    begin
      if Nx>NumOfColumns then Nx := NumOfColumns;
      if Ny>BuffEnd then Ny := BuffEnd;
    end;
    if Nx=0 then Nx := 1;
    if Ny=0 then Ny := 1;
    ChangeWindowSize(Nx,Ny);
  end;
end;

procedure VTWindow.ChangeWindowSize(Nx, Ny: integer);
var
  XRange, YRange, dW,dH: longint;
begin
  WinWidth := Nx;
  WinHeight := Ny;

  if ts.TermIsWin>0 then
  begin
    LockBuffer;
    ChangeTerminalSize(WinWidth,WinHeight);
    UnlockBuffer;
    CaretOn;
    WinWidth := NumOfColumns;
    WinHeight := NumOfLines;
    Nx := NumOfColumns;
    Ny := NumOfLines;
  end;

  ScreenWidth := Nx*FontWidth;
  ScreenHeight := Ny*FontHeight;

  if NumOfColumns-Nx>0 then
    XRange := NumOfColumns-Nx
  else
    XRange := 0;

  if BuffEnd-Ny>0 then
    YRange := BuffEnd-Ny
  else
    YRange := 0;

  if Scroller^.XPos > XRange then
    Scroller^.XPos := XRange;
  if Scroller^.YPos > YRange then
    Scroller^.YPos := YRange;

  WinOrgX := Scroller^.XPos;
  WinOrgY := Scroller^.YPos-PageStart;
  NewOrgX := WinOrgX;
  NewOrgY := WinOrgY;

  DontChangeSize := true;

  SetScrollRange(HWindow,SB_HORZ,0,XRange,false);
  Scroller^.XRange := XRange;

  if (YRange = 0) and (ts.EnableScrollBuff>0) then
  begin
    SetScrollRange(HWindow,SB_VERT,0,1,false);
    Scroller^.YRange := 0
  end
  else begin
    Scroller^.YRange := YRange;
    SetScrollRange(HWindow,SB_VERT,0,YRange,false);
  end;

  Scroller^.XPage := Nx;
  Scroller^.YPage := Ny;

  SetScrollPos(HWindow,SB_HORZ,Scroller^.XPos,true);
  SetScrollPos(HWindow,SB_VERT,Scroller^.YPos,true);

  DontChangeSize := false;

  GetClientRect(HWindow,R);
  dW := ScreenWidth - R.right + R.left;
  dH := ScreenHeight - R.bottom + R.top;
  if (dW<>0) or (dH<>0) then
  begin
    AdjustSize := true;
    SetWindowPos(HWindow,HWND_TOP,0,0,Attr.W+dW,Attr.H+dH,SWP_NOMOVE);
  end
  else
    InvalidateRect(HWindow,nil,false);
end;

procedure VTWindow.ChangeTerminalSize(Nx, Ny: integer);
var
  i, Nb, W, H: integer;
begin
  if Nx < 1 then Nx := 1;
  if Ny < 1 then Ny := 1;
  if (Nx=NumOfColumns) and (Ny=NumOfLines) then exit;
  if Nx > BuffXMax then Nx := BuffXMax;
  if Ny > BuffYMax then Ny := BuffYMax;

  if (ts.ScrollBuffMax < Ny) or
     (ts.EnableScrollBuff=0)
    then Nb := Ny
    else Nb := ts.ScrollBuffMax;

  if not ChangeBuffer(Nx,Nb) then exit;
  if ts.EnableScrollBuff>0 then
    ts.ScrollBuffMax := NumOfLinesInBuff;
  if Ny > NumOfLinesInBuff then Ny := NumOfLinesInBuff;

  NumOfColumns := Nx;
  NumOfLines := Ny;
  WinWidthOld := Nx;
  WinHeightOld := Ny;
  ts.TerminalWidth := Nx;
  ts.TerminalHeight := Ny;

  BuffScroll(NumOfLines);
  {Set Cursor}
  CursorX := 0;
  CursorY := 0;
  CursorTop := 0;
  CursorBottom := NumOfLines-1;

  SelectStart.X := 0;
  SelectStart.Y := 0;
  SelectEnd := SelectStart;
  Select := false;

  {Tab stops}
  NTabstops := (NumOfColumns-1) div 8;
  for i := 1 to NTabstops do
    TabStops[i-1] := i*8;

  if ts.TermIsWin>0 then
  begin
    W := NumOfColumns;
    H := NumOfLines;
  end
  else begin
    W := WinWidth;
    H := WinHeight;
    if (ts.AutoWinResize>0) or
      (NumOfColumns < W) then W := NumOfColumns;
    if ts.AutoWinResize>0 then H := NumOfLines
    else if BuffEnd < H then H := BuffEnd;
  end;
                              
  PageStart := BuffEnd-NumOfLines;
  Scroller^.XPos := 0;
  Scroller^.YPos := PageStart;

  {Change Window Size}
  ChangeWindowSize(W,H);

  if cv.Ready and cv.TelFlag and
     (TelnetRec.MyOpt[NAWS].Status = Yes) and
     ((NumOfColumns<>TelnetRec.WinSize.X) or
      (NumOfLines<>TelnetRec.WinSize.Y)) then
  begin
    TelnetRec.WinSize.X := NumOfColumns;
    TelnetRec.WinSize.Y := NumOfLines;
    TelInformWinSize;
  end;
end;

procedure VTWindow.ButtonDown(Msg: TMessage; LMR: word);
var
  PopupMenu, PopupBase: HMenu;
  P: TPoint;
  X, Y: integer;
begin
  if (LMR=IdLeft) and ControlKey and (Attr.Menu=0) then
  begin
    P.X := LoWord(Msg.lParam);
    P.Y := HiWord(Msg.lParam);
    ClientToScreen(HWindow, P);
    InitMenu(PopupMenu);
    InitMenuPopup(FileMenu);
    InitMenuPopup(EditMenu);
    InitMenuPopup(SetupMenu);
    InitMenuPopup(ControlMenu);
    PopupBase := CreatePopupMenu;
    AppendMenu(PopupBase, MF_STRING or MF_ENABLED or MF_POPUP,
               FileMenu, '&File');
    AppendMenu(PopupBase, MF_STRING or MF_ENABLED or MF_POPUP,
               EditMenu, '&Edit');
    AppendMenu(PopupBase, MF_STRING or MF_ENABLED or MF_POPUP,
               SetupMenu, '&Setup');
    AppendMenu(PopupBase, MF_STRING or MF_ENABLED or MF_POPUP,
               ControlMenu, 'C&ontrol');
    AppendMenu(PopupBase, MF_STRING or MF_ENABLED or MF_POPUP,
               GetSubMenu(PopupMenu,4), '&Help');
    TrackPopupMenu(PopupBase,TPM_LEFTALIGN or TPM_LEFTBUTTON,
                   P.X,P.Y,0,HWindow,nil);
    DestroyMenu(PopupBase);
    DestroyMenu(PopupMenu);
    PopupMenu := 0;
    exit;
  end;

  X := (integer(LoWord(Msg.lParam))+FontWidth div 2)
       div FontWidth + WinOrgX;
  Y := integer(HiWord(Msg.lParam)) div FontHeight + WinOrgY + PageStart;
  if X<0 then X := 0;
  if X>=NumOfColumns then X := NumOfColumns-1;

  if (Y>=0) and (Y<BuffEnd) then
    if DblClk and (LMR=IdLeft) and
       (abs(LoWord(Msg.lParam)-DblClkX)<=GetSystemMetrics(SM_CXDOUBLECLK)) and
       (abs(HiWord(Msg.lParam)-DblClkY)<=GetSystemMetrics(SM_CYDOUBLECLK)) then
    begin {triple click}
      KillTimer(HWindow, IdDblClkTimer);
      DblClk := false;
      LockBuffer;
      SelectEnd := SelectStart;
      ChangeSelectRegion;
      SelectStart.X := 0;
      SelectStart.Y := Y;
      SelectEnd.X := NumOfColumns;
      SelectEnd.Y := Y;
      SelectEndOld := SelectStart;
      Select := true;
      ChangeSelectRegion;
      CBCopy(HWindow);
      UnlockBuffer;
      TplClk := true;
    end
    else begin
      if not (LButton or MButton or RButton) then
      begin
        SelectEndOld := SelectEnd;
        SelectEnd := SelectStart;

        LockBuffer;
        ChangeSelectRegion;
        UnlockBuffer;

        SelectStart.X := X;
        SelectStart.Y := Y;
        SelectEnd := SelectStart;
        SelectEndOld := SelectEnd;
        CaretOff;
        TplClk := false;
        Select := true;
        {for AutoScrolling}
        SetCapture(HWindow);
        SetTimer(HWindow, IdScrollTimer, 100, nil);
      end;
      case LMR of
        IdRight: RButton := true;
        IdMiddle: MButton := true;
        IdLeft: LButton := true;
      end;
    end;
end;

procedure VTWindow.WMLButtonDown(Var Msg: TMessage);
begin
  ButtonDown(Msg,IdLeft);
end;

procedure VTWindow.WMNCRButtonDown(Var Msg: TMessage);
begin
  if (Msg.wParam=HTCAPTION) and
     (ts.HideTitle>0) and
     AltKey then
    WINPROCS.CloseWindow(HMainWin);
end;

procedure VTWindow.WMMButtonDown(Var Msg: TMessage);
begin
  ButtonDown(Msg,IdMiddle);
end;

procedure VTWindow.WMRButtonDown(Var Msg: TMessage);
begin
  ButtonDown(Msg,IdRight);
end;


procedure VTWindow.ButtonUp(Paste: boolean);
begin
  {disable autoscrolling}
  KillTimer(HWindow,IdScrollTimer);
  ReleaseCapture;

  Select := (SelectStart.X<>SelectEnd.X) or (SelectStart.Y<>SelectEnd.Y);
  LButton := false;
  MButton := false;
  RButton := false;
  CaretOn;

  if Select then
  begin
    if (SelectEnd.Y < SelectStart.Y) or
       ((SelectEnd.Y = SelectStart.Y) and (SelectEnd.X < SelectStart.X)) then
    begin
      SelectEndOld := SelectStart;
      SelectStart := SelectEnd;
      SelectEnd := SelectEndOld;
    end;
    {copy to the clipboard}
    LockBuffer;
    CBCopy(HWindow);
    UnlockBuffer;
  end;
  if Paste then
    CBStartPaste(HWindow);
end;

procedure VTWindow.WMLButtonUp(Var Msg: TMessage);
begin
  if not LButton then exit;
  ButtonUp(false);
end;

procedure VTWindow.WMMButtonUp(Var Msg: TMessage);
begin
  if not MButton then exit;
  ButtonUp(true);
end;

procedure VTWindow.WMRButtonUp(Var Msg: TMessage);
begin
  if not RButton then exit;
  ButtonUp(true);
end;

procedure VTWindow.ButtonDblClk(Msg: TMessage);
var
  X, Y, IStart, IEnd: integer;
  TmpPtr: longint;
begin
  DblClkX := LoWord(Msg.lParam);
  DblClkY := HiWord(Msg.lParam);
  X := (integer(LoWord(Msg.lParam))) div FontWidth + WinOrgX;
  Y := integer(HiWord(Msg.lParam)) div FontHeight + WinOrgY + PageStart;
  if X<0 then X := 0;
  if X>=NumOfColumns then X := NumOfColumns-1;

  if (Y>=0) and (Y<BuffEnd) then
  begin

    LockBuffer;
    TmpPtr := GetLinePtr(Y);
    IStart := X;
    while (IStart>0) and (CodeBuff[TmpPtr+IStart]<>#$20) do
      dec(IStart);
    if CodeBuff[TmpPtr+IStart]=#$20 then inc(IStart);
    IEnd := X;
    while (IEnd<NumOfColumns) and (CodeBuff[TmpPtr+IEnd]<>#$20) do
      inc(IEnd);
    if IStart<=X then
    begin
      SelectStart.X := IStart;
      SelectStart.Y := Y;
      SelectEnd.X := IEnd;
      SelectEnd.Y := Y;
      SelectEndOld := SelectStart;
      Select := true;
      ChangeSelectRegion;
      {Copy to the clipboard}
      CBCopy(HWindow);
    end;
    UnlockBuffer;
  end;

  DblClk := true;
  SetTimer(HWindow, IdDblCLKTimer, GetDoubleClickTime, nil);
end;

procedure VTWindow.WMLButtonDblClk(Var Msg: TMessage);
begin
  if TplClk then exit;
  ButtonDblClk(Msg);
end;

procedure VTWindow.WMMouseMove(Var Msg: TMessage);
var
  X, Y: integer;
begin
  if not (LButton or MButton or RButton) then exit;

  X := (integer(LoWord(Msg.lParam)) + FontWidth div 2)
       div FontWidth + WinOrgX;
  Y := integer(HiWord(Msg.lParam)) div FontHeight + WinOrgY + PageStart;

  SelectEnd.X := X;
  SelectEnd.Y := Y;

  if (SelectEnd.Y < SelectStart.Y) or (SelectEnd.Y=SelectStart.Y)and(SelectEnd.X<SelectStart.X)
  then begin
    Inc(SelectEnd.X);
    if SelectEnd.X>=NumOfColumns then
    begin
      SelectEnd.X := 0;
      Inc(SelectEnd.Y);
    end;
  end;

  if SelectEnd.X < 0 then SelectEnd.X := 0;
  if SelectEnd.X > NumOfColumns then SelectEnd.X := NumOfColumns;

  if SelectEnd.Y < 0 then SelectEnd.Y := 0;
  if SelectEnd.Y >= BuffEnd then SelectEnd.Y := BuffEnd - 1;

  LockBuffer;
  ChangeSelectRegion;
  UnlockBuffer;
end;

procedure VTWindow.ChangeSelectRegion;
var
  TempStart, TempEnd: TPoint;
  j, IStart, IEnd: integer;
  TempDC: HDC;
begin
  if (SelectEndOld.X=SelectEnd.X) and (SelectEndOld.Y=SelectEnd.Y) then exit;

  if (SelectEndOld.Y < SelectEnd.Y) or (SelectEndOld.Y=SelectEnd.Y)and(SelectEndOld.X<=SelectEnd.X)
  then begin
    TempStart := SelectEndOld;
    TempEnd.X := SelectEnd.X-1;
    TempEnd.Y := SelectEnd.Y;
  end
  else begin
    TempStart := SelectEnd;
    TempEnd.X := SelectEndOld.X-1;
    TempEnd.Y := SelectEndOld.Y;
  end;
  if TempEnd.X < 0 then
  begin
    TempEnd.X := NumOfColumns - 1;
    Dec(TempEnd.Y);
  end;

  for j := TempStart.Y to TempEnd.Y do
  begin
    IStart := 0;
    IEnd := NumOfColumns-1;
    if j=TempStart.Y then IStart := TempStart.X;
    if j=TempEnd.Y then IEnd := TempEnd.X;

    if (IEnd>=IStart) and (j >= Scroller^.YPos) and (j < Scroller^.YPos+WinHeight) then
    begin
      TempDC := GetDC(HWindow);
      UpdateRect(TempDC,IStart,j-Scroller^.YPos+WinOrgY,IEnd,j-Scroller^.YPos+WinOrgY);
      ReleaseDC(HWindow,TempDC);
    end;
  end;

  SelectEndOld := SelectEnd;

 end;

 procedure VTWindow.WMNCLButtonDblClk(var Msg: TMessage);
 begin
   if not MiniMized and (Msg.wParam = HTCaption) then
     if (WinWidth=NumOfColumns) and (WinHeight=NumOfLines) then
     begin
       if WinWidthOld > NumOfColumns then
         WinWidthOld := NumOfColumns;
       if WinHeightOld > BuffEnd then
         WinHeightOld := BuffEnd;
       if ts.TermIsWin=0 then
         ChangeWindowSize(WinWidthOld,WinHeightOld)
     end
     else begin
       WinWidthOld := WinWidth;
       WinHeightOld := WinHeight;
       ChangeWindowSize(NumOfColumns,NumOfLines);
     end;

   TWindow.DefWndProc(Msg);
 end;

 procedure VTWindow.WMMove(var Msg: TMessage);
 var
   CaretX, CaretY: integer;
   Point: TPoint;
 begin
   TWindow.WMMove(Msg);
   ts.VTPos.x := Attr.x;
   ts.VTPos.y := Attr.y;

   if (HWINNLS>=32) and (ts.IMEInline > 0) then
   begin
     CaretX := (CursorX-WinOrgX)*FontWidth;
     CaretY := (CursorY-WinOrgY)*FontHeight;
     {set IME conversion window pos.}
     SetConversionWindow(HWindow,CaretX,CaretY,VTFont[0]);
   end;

   Point.X := 0;
   Point.Y := ScreenHeight;
   ClientToScreen(HWindow,Point);
   CompletelyVisible := Point.Y <= CRTHeight;
 end;

 procedure VTWindow.WMSysColorChange(var Msg: TMessage);
 begin
   if HCtl3d>=32 then Ctl3dColorChange;
 end;

procedure VTWindow.WMSysCommand(var Msg: TMessage);
begin
  case Msg.wParam of
    cm_ShowMenubar:
      begin
        ts.PopupMenu := 0;
        SwitchMenu;
      end;
  else
    DefWndProc(Msg);
  end;
end;

 procedure VTWindow.WMDdeEnd(var Msg: TMessage);
 begin
   EndDde;
   if CloseTT then
     CloseWindow;
 end;

procedure VTWindow.WMAccelCommand(var Msg: TMessage);
begin
  case Msg.wParam of
    IdAccEditCopy:
      CMEditCopy(Msg);
    IdAccEditPaste:
      CMEditPaste(Msg);
    IdAccEditPasteCR:
      CMEditPasteCR(Msg);
    IdAccLineUp:
      Scroller^.ScrollBy(0,-1);
    IdAccLineDown:
      Scroller^.ScrollBy(0,1);
    IdAccPageUp:
      Scroller^.ScrollBy(0,-WinHeight+1);
    IdAccPageDown:
      Scroller^.ScrollBy(0,WinHeight-1);
    IdAccBuffTop:
      Scroller^.ScrollTo(WinOrgX,0);
    IdAccBuffBottom:
      Scroller^.ScrollTo(WinOrgX,BuffEnd);
    IdAccSendBreak:
      CMControlSendBreak(Msg);
  end;
  CaretOn;
end;

procedure VTWindow.WMChangeMenu(var Msg: TMessage);
var
  SysMenu: HMenu;
begin
  if (ts.PopupMenu>0) and (Attr.Menu<>0)  or
     (ts.PopupMenu=0) and (Attr.Menu=0) then
  begin
    if ts.PopupMenu>0 then
    begin
      DestroyMenu(Attr.Menu);
      Attr.Menu := 0;
    end
    else
      InitMenu(Attr.Menu);
    WinWidthOld := WinWidth;
    WinHeightOld := WinHeight;
    AdjustSize := true;
    SetMenu(HWindow, Attr.Menu);
    DrawMenuBar(HWindow);
  end;

  GetSystemMenu(HWindow,true);
  if ts.PopupMenu>0 then
  begin
    SysMenu := GetSystemMenu(HWindow,false);
    AppendMenu(SysMenu, mf_Separator, 0, nil);
    AppendMenu(SysMenu, mf_String, cm_ShowMenubar, 'Show menu &bar');
  end;
end;

procedure VTWindow.WMCloseIME(var Msg: TMessage);
begin
  OpenConv := FALSE;
end;

procedure VTWindow.WMComNotify(var Msg: TMessage);
begin
  case LoWord(Msg.lParam) of
    FD_READ: CommProcRRQ(@cv);
    FD_OOB: begin
        CommProcOOB(@cv);
      end;
    FD_CLOSE: begin
        Connecting := false;
        cv.Ready := false;
        SetTimer(HWindow, IdComEndTimer,1,nil);
      end;
  end;
end;

procedure VTWindow.WMComOpen(var Msg: TMessage);
begin
  CommStart(@cv,Msg.lParam);
  Connecting := false;
  ChangeTitle;
  if not cv.Ready then exit;
  SetDdeComReady(1);
  if cv.TelFlag then
  begin
    InitTelnet;
   {Telnet Option Negotiation}

    TelEnableMyOpt(TermType);

    TelEnableHisOpt(SGA);

    TelEnableMyOpt(SGA);

    TelEnableHisOpt(ECHO);

    TelEnableMyOpt(NAWS);
    if ts.TelBin>0 then
    begin
      TelEnableMyOpt(BINARY);
      TelEnableHisOpt(BINARY);
    end;
  end;

  if DDELog or FileLog then
  begin
    if not CreateLogBuf then
    begin
      if DDELog then EndDDE;
      if FileLog then LogEnd;
    end;
  end;

  if BinLog then
  begin
    if not CreateBinBuf then
      LogEnd;
  end;
end;

procedure VTWindow.WMComStart(var Msg: TMessage);
begin
  if (ts.PortType<>IdSerial) and (ts.HostName[0]=#0) then
    CMFileNewConnection(Msg)
  else begin
    Connecting := true;
    ChangeTitle;
    CommOpen(HWindow,@ts,@cv);
  end;
end;

procedure VTWindow.WMDlgHelp(var Msg: TMessage);
begin
  OpenHelp(HMainWin,HELP_CONTEXT,HelpId);
end;
